Option Explicit

Const MAX_SIZE = 5

'These are 2 arrays of form references. Initially
'they're empty. They're allocated and expanded in the
'subroutines CreateNewBoy() and CreateNewGirl().
Global boys() As frmMale
Global girls() As frmFemale

'These 2 variables hold the subscript of the current
'empty slot in the 2 arrays above.
Global currentBoy As Integer
Global currentGirl As Integer

'These 2 variables store the current size of the 2 arrays.
'Both of these can increase as the program expands the arrays.
Dim boyCount As Integer
Dim girlCount As Integer

Dim TotalChildren As Integer

'These used-defined types are used to hold any variables that
'logically belong to the individual instances of the child forms,
'but that must be accessible outside the form. The arrays will
'be sized and resized as needed.
Type BoyRecord
    dirtyflag As Integer
End Type
Global boydata() As BoyRecord


Type GirlRecord
    dirtyflag As Integer
End Type
Global girldata() As GirlRecord

' Arrange Method for MDI Forms
Global Const CASCADE = 0
Global Const TILE_HORIZONTAL = 1
Global Const TILE_VERTICAL = 2
Global Const ARRANGE_ICONS = 3

' QueryUnload
Global Const FORM_CONTROLMENU = 0
Global Const FORM_CODE = 1
Global Const APP_WINDOWS = 2
Global Const APP_TASKMANAGER = 3
Global Const FORM_MDIFORM = 4

' WindowState
Global Const NORMAL = 0    ' 0 - Normal
Global Const MINIMIZED = 1 ' 1 - Minimized
Global Const MAXIMIZED = 2 ' 2 - Maximized

' MsgBox parameters
Global Const MB_OK = 0                 ' OK button only
Global Const MB_OKCANCEL = 1           ' OK and Cancel buttons
Global Const MB_ABORTRETRYIGNORE = 2   ' Abort, Retry, and Ignore buttons
Global Const MB_YESNOCANCEL = 3        ' Yes, No, and Cancel buttons
Global Const MB_YESNO = 4              ' Yes and No buttons
Global Const MB_RETRYCANCEL = 5        ' Retry and Cancel buttons
Global Const MB_ICONSTOP = 16          ' Critical message
Global Const MB_ICONQUESTION = 32      ' Warning query
Global Const MB_ICONEXCLAMATION = 48   ' Warning message
Global Const MB_ICONINFORMATION = 64   ' Information message

Global Const MB_APPLMODAL = 0          ' Application Modal Message Box
Global Const MB_DEFBUTTON1 = 0         ' First button is default
Global Const MB_DEFBUTTON2 = 256       ' Second button is default
Global Const MB_DEFBUTTON3 = 512       ' Third button is default
Global Const MB_SYSTEMMODAL = 4096      'System Modal

' MsgBox return values
Global Const IDOK = 1                  ' OK button pressed
Global Const IDCANCEL = 2              ' Cancel button pressed
Global Const IDABORT = 3               ' Abort button pressed
Global Const IDRETRY = 4               ' Retry button pressed
Global Const IDIGNORE = 5              ' Ignore button pressed
Global Const IDYES = 6                 ' Yes button pressed
Global Const IDNO = 7                  ' No button pressed

Sub CenterControl (button As Control)
    'This subroutine centers the incoming control on its form.
    button.Top = (MDIParent.ActiveForm.ScaleHeight - button.Height) / 2
    button.Left = (MDIParent.ActiveForm.ScaleWidth - button.Width) / 2
End Sub

Sub CloseCurrentBoy (i As Integer)
    Unload boys(i)
    Set boys(i) = Nothing

    TotalChildren = TotalChildren - 1
    If TotalChildren = 0 Then
	SetParentControls
    End If
End Sub

Sub CloseCurrentGirl (i As Integer)
    Unload girls(i)
    Set girls(i) = Nothing

    TotalChildren = TotalChildren - 1
    If TotalChildren = 0 Then
	SetParentControls
    End If
End Sub

Sub CreateNewBoy ()
    'For the very first boy child, it's necessary to size the 2 arrays.
    'No new child is needed: used the one obtained at design time.
    If currentBoy = 0 Then
	currentBoy = 1
	boyCount = MAX_SIZE
	ReDim boys(boyCount)
	ReDim boydata(boyCount)
	Set boys(currentBoy) = frmMale
    Else
	
	'First, create a new instance of a boy child.
	Dim newboy As New frmMale

	'Next, determine if the arrays need to be expanded
	If currentBoy > boyCount Then
	    boyCount = boyCount + MAX_SIZE
	    ReDim Preserve boys(boyCount)
	    ReDim Preserve boydata(boyCount)
	End If
	
	'Finally, 'point' to the newest boy.
	Set boys(currentBoy) = newboy
    End If

    'Set the caption, create a tag, and show the child.
    boys(currentBoy).Caption = "Boy # " & currentBoy
    boys(currentBoy).Tag = Str$(currentBoy)
    boys(currentBoy).Show
    
    'Bump the counter.
    currentBoy = currentBoy + 1
    MDIParent.Image3.Enabled = True
    TotalChildren = TotalChildren + 1
End Sub

Sub CreateNewGirl ()
    'For the very first girl child, it's necessary to size the 2 arrays.
    'No new child is needed: used the one obtained at design time.
    If currentGirl = 0 Then
	currentGirl = 1
	girlCount = MAX_SIZE
	ReDim girls(girlCount)
	ReDim girldata(girlCount)
	Set girls(currentGirl) = frmFemale
    Else
	
	'First, create a new instance of a girl child.
	Dim newgirl As New frmFemale

	'Next, determine if the arrays need to be expanded
	If currentGirl > girlCount Then
	    girlCount = girlCount + MAX_SIZE
	    ReDim Preserve girls(girlCount)
	    ReDim Preserve girldata(girlCount)
	End If
	
	'Finally, 'point' to the newest girl.
	Set girls(currentGirl) = newgirl
    End If

    'Set the caption, create a tag, and show the child.
    girls(currentGirl).Caption = "Girl # " & currentGirl
    girls(currentGirl).Tag = Str$(currentGirl)
    girls(currentGirl).Show
    
    'Bump the counter.
    currentGirl = currentGirl + 1
    MDIParent.Image3.Enabled = True
    TotalChildren = TotalChildren + 1
End Sub

Function GetWindowState (ThisForm As Form) As String
    Dim WinState As String
    
    Select Case ThisForm.WindowState
	Case 0
	    WinState = "Default"
	Case 1
	    WinState = "Minimized"
	Case 2
	    WinState = "Maximized"
    End Select

    GetWindowState = WinState

End Function

Sub SetParentControls ()
    MDIParent.Image3.Enabled = False
    MDIParent.lblStatus(1).Caption = "MENU: PARENT"
    MDIParent.lblStatus(2).Caption = "No Children"
    MDIParent.lblStatus(3).Caption = "Windowstate:"
End Sub

