VERSION 2.00
Begin Form frmSaveAs 
   Caption         =   "File Save - Enter a file name"
   ClientHeight    =   3600
   ClientLeft      =   3195
   ClientTop       =   2565
   ClientWidth     =   5025
   Height          =   4005
   Icon            =   SAVEAS.FRX:0000
   Left            =   3135
   LinkMode        =   1  'Source
   LinkTopic       =   "Form1"
   ScaleHeight     =   3600
   ScaleWidth      =   5025
   Top             =   2220
   Width           =   5145
   Begin DirListBox Dir1 
      Height          =   1845
      Left            =   105
      TabIndex        =   2
      Top             =   1620
      Width           =   3240
   End
   Begin DriveListBox Drive1 
      Height          =   1530
      Left            =   105
      TabIndex        =   1
      Top             =   1200
      Width           =   3255
   End
   Begin CommandButton cmdCancel 
      Cancel          =   -1  'True
      Caption         =   "&Cancel"
      Height          =   495
      Left            =   3585
      TabIndex        =   4
      Top             =   750
      Width           =   1215
   End
   Begin TextBox txtFileName 
      Height          =   345
      Left            =   105
      MaxLength       =   8
      TabIndex        =   0
      Top             =   390
      Width           =   1485
   End
   Begin CommandButton cmdOK 
      Caption         =   "&OK"
      Default         =   -1  'True
      Enabled         =   0   'False
      Height          =   495
      Left            =   3570
      TabIndex        =   3
      Top             =   105
      Width           =   1215
   End
   Begin Label lblPath 
      Caption         =   "*.txt"
      Height          =   320
      Left            =   105
      TabIndex        =   5
      Top             =   840
      Width           =   3240
   End
   Begin Label lblFileName 
      Caption         =   "File Name:"
      Height          =   300
      Left            =   105
      TabIndex        =   6
      Top             =   100
      Width           =   1785
   End
End
Option Explicit

Sub cmdCancel_Click ()
    'User wants to cancel

    'Make fname = blank
    fname = ""

    'Unload the SAVEAS.FRM
    Unload frmSaveAs

End Sub

Sub cmdOK_Click ()
    'Handle bad filename situations
    If InStr(txtFileName.Text, "\") <> 0 Or InStr(txtFileName.Text, ":") <> 0 Then
        MsgBox "Enter filename only.  Use the file controls provided to select the proper drive and directory.", OK + WARNINGQUERY + FIRSTBUTTON, "Invalid Filename"
    Else
        'Build correct path and filename for fname
        fname = Dir1.Path
        If Right$(fname, 1) <> "\" Then fname = fname + "\"
        fname = fname + txtFileName.Text

        'Append a .txt extension
        If Right$(fname, 4) <> "." Then fname = fname + ".txt"
        
        'Unload the SAVEAS.FRM
        Unload frmSaveAs
    End If

End Sub

Sub Dir1_Change ()
    'Update the machine's current directory
    ChDir (Dir1.Path)

    'Update the label caption
    lblPath.Caption = Dir1.Path
End Sub

Sub Drive1_Change ()
    Dim rc As Integer

    'Set the drive error trap
    On Error GoTo SaveDriveError

    'Update the directory list
    Dir1.Path = Drive1.Drive

    'Unset the drive error trap
    On Error GoTo 0
    Exit Sub

SaveDriveError:

    'Debug logic
    MsgBox "The error is: " + Str$(Err) + " " + Error$
   
    'Determine the File Error
    Select Case Err
        Case 68 'Device Unavailable
            rc = MsgBox(" Drive Not Ready   ", ABORTRETRYIGNORE + WARNINGMESSAGE, "DRIVE ERROR")
        Case Else ' Any other error
            rc = MsgBox("Some other error " + Str$(Err) + " " + Error$, OK, "Unknown Error")
    End Select
              
    'Process which key user pressed

    Select Case rc
        Case KEYRETRY
            'Try again
            Resume
        Case KEYIGNORE
            'Ignore, go on to next line
            'Note that the drive has not really changed
            Resume Next
        Case KEYABORT
            'Return to previous drive setting & Resume
            Drive1.Drive = Left$(Dir1.Path, 2)
            Resume
        Case Else
            'Unexpected key value
            MsgBox "Unexpected results, key = " + Str$(rc), CRITICAL, "KEYERROR"
            'End the Application
            End
    End Select

End Sub

Sub Form_Load ()
    Dir1_Change
End Sub

Sub txtFileName_Change ()
    'Decide whether to enable the OK button
    If txtFileName.Text <> "" Then
        cmdOK.Enabled = True
    Else
        cmdOK.Enabled = False
    End If
End Sub

