VERSION 2.00
Begin Form frmMPBE 
   Caption         =   "Multiple Paste Buffer Editor"
   ClientHeight    =   2235
   ClientLeft      =   1395
   ClientTop       =   3105
   ClientWidth     =   4725
   Height          =   2925
   Left            =   1335
   LinkTopic       =   "Form1"
   ScaleHeight     =   2235
   ScaleWidth      =   4725
   Top             =   2475
   Width           =   4845
   Begin CommonDialog CMDialog1 
      Left            =   4080
      Top             =   720
   End
   Begin TextBox txtEditBox 
      Height          =   1695
      Left            =   360
      MultiLine       =   -1  'True
      ScrollBars      =   3  'Both
      TabIndex        =   0
      Top             =   240
      Width           =   3495
   End
   Begin Menu mnuFile 
      Caption         =   "&File"
      Begin Menu mnuFileNew 
         Caption         =   "&New"
      End
      Begin Menu mnuFileOpen 
         Caption         =   "&Open..."
      End
      Begin Menu mnuFileSave 
         Caption         =   "&Save"
      End
      Begin Menu mnuFileSaveExit 
         Caption         =   "Save &and Exit"
      End
      Begin Menu mnuFileExit 
         Caption         =   "E&xit"
      End
   End
End
Option Explicit

'lcv (loop control variable) is used in many places
'to drive a for/next loop
Dim lcv As Integer

'dirtyflag is set to value whenever txtEditBox changes
Dim dirtyflag As Integer

'fhandle and fname are used to open (and close) the file.
Dim fhandle As Integer
Dim fname As String

Const FormTitle = "Multiple Paste Buffer Editor v1.0"

Sub Form_Load ()
    'make the form take over the entire screen
    Height = screen.Height
    Width = screen.Width
    Top = 0
    Left = 0
    
    frmMPBE.Caption = FormTitle + " (untitled)"
    
    'Set up the common dialog box.
    CMDialog1.Filter = "Text Files (*.txt)|*.txt|All files (*.*)|*.*"

End Sub

Sub Form_QueryUnload (Cancel As Integer, UnloadMode As Integer)
    Dim rc As Integer
    Const YES = 6

    If dirtyflag Then
        rc = MsgBox("Save changes before terminating?", 4, "File has changed!")
        If rc = YES Then
            mnuFileSave_Click
        End If
    End If
End Sub

Sub Form_Resize ()
    'Always make the text box as large as its containing form.
    txtEditBox.Width = frmMPBE.ScaleWidth
    txtEditBox.Height = frmMPBE.ScaleHeight
    
    txtEditBox.Left = 0
    txtEditBox.Top = 0
End Sub

Sub mnuFileExit_Click ()
    Dim rc As Integer
    Const YES = 6

    If dirtyflag Then
        rc = MsgBox("Save changes before terminating?", 4, "File has changed!")
        If rc = YES Then
            mnuFileSave_Click
        End If
    End If
    
    'Terminate
    End
End Sub

Sub mnuFileNew_Click ()
    Const YES = 6
    Dim rc As Integer

    If dirtyflag = True Then
        rc = MsgBox("Save changes before a fresh start?", 4, "Text has changed!")
        If rc = YES Then
            mnuFileSave_Click
        End If
    End If
    fname = ""
    txtEditBox.Text = ""
    dirtyflag = False
    frmMPBE.Caption = FormTitle + " (untitled)"
End Sub

Sub mnuFileOpen_Click ()
    Const YES = 6
    Dim rc As Integer

    If dirtyflag = True Then
        rc = MsgBox("Save changes before opening a new file?", 4, "Text has changed!")
        If rc = YES Then
            mnuFileSave_Click
        End If
    End If

    'Invoke the Dialog Box
    CMDialog1.Action = 1

    'if fname is empty, then exit
    fname = CMDialog1.Filename
    If fname = "" Then
        Beep
        Exit Sub
    End If

    'Build the title without a path.
    frmMPBE.Caption = FormTitle + " (" + CMDialog1.Filetitle + ")"
    
    'Get a fresh handle and read the file in.
    fhandle = FreeFile
    Open fname For Input As fhandle
    txtEditBox.Text = Input$(LOF(fhandle), fhandle)
    dirtyflag = False
    Close fhandle
End Sub

Sub mnuFileSave_Click ()
    If dirtyflag = False Then
        Exit Sub
    End If
    
    'Get a fresh handle and write the file to it.
    If fname = "" Then
        fname = InputBox$("Enter a file name. File will be saved in " + CurDir$, "No file name available!")
        frmMPBE.Caption = FormTitle + " (" + fname + ")"
    End If
    
    'Now if fname is empty, it's OK to terminate this subroutine.
    If fname = "" Then
        Exit Sub
    End If

    fhandle = FreeFile
    Open fname For Output As fhandle
    Print #fhandle, txtEditBox.Text
    Close fhandle
    dirtyflag = False
End Sub

Sub mnuFileSaveExit_Click ()
    mnuFileSave_Click
    End
End Sub

Sub txtEditBox_Change ()
    dirtyflag = True
End Sub

