VERSION 2.00
Begin Form frmMDIChild 
   Caption         =   "Child"
   ClientHeight    =   1230
   ClientLeft      =   1305
   ClientTop       =   4665
   ClientWidth     =   3645
   Height          =   1920
   Left            =   1245
   LinkTopic       =   "Form1"
   MDIChild        =   -1  'True
   ScaleHeight     =   1230
   ScaleWidth      =   3645
   Top             =   4035
   Width           =   3765
   Begin TextBox txtEditBox 
      Height          =   975
      Left            =   0
      MultiLine       =   -1  'True
      ScrollBars      =   3  'Both
      TabIndex        =   0
      Top             =   0
      Width           =   2415
   End
   Begin Menu mnuFile 
      Caption         =   "&File"
      Begin Menu mnuFileNew 
         Caption         =   "&New Child"
      End
      Begin Menu mnuFileOpen 
         Caption         =   "&Open File..."
      End
      Begin Menu mnuFileClose 
         Caption         =   "&Close Window"
      End
      Begin Menu mnuFileSep1 
         Caption         =   "-"
      End
      Begin Menu mnuFileSave 
         Caption         =   "&Save File"
      End
      Begin Menu mnuFileSep2 
         Caption         =   "-"
      End
      Begin Menu mnuFileExit 
         Caption         =   "E&xit"
      End
   End
   Begin Menu mnuEdit 
      Caption         =   "&Edit"
      Begin Menu mnuEditCutSys 
         Caption         =   "Cut to System Buffer"
         Shortcut        =   ^X
      End
      Begin Menu mnuEditCopySys 
         Caption         =   "Copy to System Buffer"
         Shortcut        =   ^C
      End
      Begin Menu mnuEditPasteSys 
         Caption         =   "Paste from System Buffer"
         Shortcut        =   ^V
      End
   End
   Begin Menu mnuWindows 
      Caption         =   "&Windows"
      WindowList      =   -1  'True
      Begin Menu mnuWindowsMinimize 
         Caption         =   "&Minimize All Windows"
      End
      Begin Menu mnuWindowsRestore 
         Caption         =   "&Restore All Windows"
      End
      Begin Menu mnuSep4 
         Caption         =   "-"
      End
      Begin Menu mnuWindowsCascade 
         Caption         =   "&Cascade"
      End
      Begin Menu mnuWindowsTile 
         Caption         =   "&Tile"
      End
      Begin Menu mnuWindowsArrange 
         Caption         =   "&Arrange Icons"
      End
      Begin Menu mnuSep3 
         Caption         =   "-"
      End
   End
End
Option Explicit

'These constants are used for sizing controls and this form.
Const ICON_HEIGHT = 1000
Const BORDER_SCROLL_WIDTH = 340

Sub CloseCurrentEditor (index As Integer)
    Unload Editors(index)
    Set Editors(index) = Nothing
    EditorData(index).dirtyflag = False
    EditorData(index).filename = ""
End Sub

Sub Form_Resize ()
    'These statements will keep the text box and paste
    'buffers in proportion to the size of the form.
    txtEditBox.Width = Me.ScaleWidth
    txtEditBox.Height = Me.ScaleHeight
End Sub

Sub Form_Unload (Cancel As Integer)
    'Pass TRUE to cause the subroutine to query the user.
    SaveCurrentEditor DO_QUERY
    CloseCurrentEditor Val(Me.Tag)
End Sub

Sub mnuEdit_Click ()
    'Only enable pasting if there's text in the clipboard.
    mnueditpastesys.Enabled = Clipboard.GetFormat(CF_TEXT)
    
    'If something is highlighted then set system
    'cut/copy options to reflect highlighting status.
    If txtEditBox.SelLength = 0 Then
	mnueditcutsys.Enabled = False
	mnueditcopysys.Enabled = False
    Else
	mnueditcutsys.Enabled = True
	mnueditcopysys.Enabled = True
    End If
    
End Sub

Sub mnuEditCopySys_Click ()
    Clipboard.SetText txtEditBox.SelText
End Sub

Sub mnuEditCutSys_Click ()
    Clipboard.SetText txtEditBox.SelText
    txtEditBox.SelText = ""
End Sub

Sub mnuEditPasteSys_Click ()
     txtEditBox.SelText = Clipboard.GetText()
End Sub

Sub mnuFileClose_Click ()
    Unload Me
End Sub

Sub mnuFileExit_Click ()
    'If the user clicks on this, then the entire process, including all
    'MDI children, must be shut down. Unloading the MDI parent will
    'automatically trigger a call to each child's QueryUnload event,
    'where the appropriate action is taken.
    Unload frmMDIParent
End Sub

Sub mnuFileNew_Click ()
    CreateNewEditor ""
End Sub

Sub mnuFileOpen_Click ()
    'The code here is the same as that of the parent.
    Dim fname As String
    
    fname = GetFileName()
    If fname = "" Then
	Exit Sub
    End If

    CreateNewEditor fname
End Sub

Sub mnuFileSave_Click ()
    SaveCurrentEditor NO_QUERY
End Sub

Sub mnuWindowsArrange_Click ()
   frmMDIParent.Arrange ARRANGE_ICONS
End Sub

Sub mnuWindowsCascade_Click ()
   frmMDIParent.Arrange CASCADE
End Sub

Sub mnuWindowsMinimize_Click ()
    Dim i As Integer
    'Iterate through all the forms.  If a form is an MDIChild, minimize it.
    For i = 0 To forms.Count - 1
	If TypeOf forms(i) Is frmMDIChild Then
	    forms(i).WindowState = MINIMIZED
	End If
    Next i

End Sub

Sub mnuWindowsRestore_Click ()
    Dim i As Integer
    'Iterate through all the forms.  If a form is an MDIChild, set its
    'WindowState to normal
    For i = 0 To forms.Count - 1
	If TypeOf forms(i) Is frmMDIChild Then
	    If forms(i).WindowState <> NORMAL Then
		forms(i).WindowState = NORMAL
	    End If
	End If
    Next i

End Sub

Sub mnuWindowsTile_Click ()
   frmMDIParent.Arrange TILE_HORIZONTAL
End Sub

Sub txtEditBox_Change ()
    Dim i As Integer
    
    i = Val(Me.Tag)
    EditorData(i).dirtyflag = True
End Sub

