VERSION 2.00
Begin Form frmMPBE 
   Caption         =   "Multiple Paste Buffer Editor"
   ClientHeight    =   2160
   ClientLeft      =   1020
   ClientTop       =   3285
   ClientWidth     =   7305
   Height          =   2850
   Left            =   960
   LinkTopic       =   "Form1"
   ScaleHeight     =   2160
   ScaleWidth      =   7305
   Top             =   2655
   Width           =   7425
   Begin CommonDialog CMDialog1 
      Left            =   3840
      Top             =   1560
   End
   Begin TextBox Text1 
      Height          =   1095
      Index           =   1
      Left            =   3720
      MultiLine       =   -1  'True
      TabIndex        =   1
      Top             =   240
      Width           =   3255
   End
   Begin TextBox txtEditBox 
      Height          =   1695
      Left            =   0
      MultiLine       =   -1  'True
      ScrollBars      =   3  'Both
      TabIndex        =   0
      Top             =   0
      Width           =   3495
   End
   Begin Label Label1 
      Caption         =   "Paste Buffer #1"
      Height          =   255
      Index           =   1
      Left            =   3720
      TabIndex        =   2
      Top             =   0
      Width           =   1455
   End
   Begin Menu mnuFile 
      Caption         =   "&File"
      Begin Menu mnuFileNew 
         Caption         =   "&New"
      End
      Begin Menu mnuFileOpen 
         Caption         =   "&Open..."
      End
      Begin Menu mnuFileSave 
         Caption         =   "&Save"
      End
      Begin Menu mnuFileSaveExit 
         Caption         =   "Save &and Exit"
      End
      Begin Menu mnuFileExit 
         Caption         =   "E&xit"
      End
   End
   Begin Menu mnuEdit 
      Caption         =   "&Edit"
      Begin Menu mnuEditCut 
         Caption         =   "Cut to Buffer #1"
      End
      Begin Menu mnuEditSep1 
         Caption         =   "-"
      End
      Begin Menu mnuEditCopy 
         Caption         =   "Copy to Buffer #1"
      End
      Begin Menu mnuEditSep2 
         Caption         =   "-"
      End
      Begin Menu mnuEditPaste 
         Caption         =   "Paste from Buffer #1"
      End
   End
   Begin Menu mnuBuffer 
      Caption         =   "&Buffers"
      Begin Menu mnuBufferAdd 
         Caption         =   "Add"
      End
      Begin Menu mnuBufferRemove 
         Caption         =   "Remove"
      End
   End
   Begin Menu mnuOptions 
      Caption         =   "&Options"
      Begin Menu mnuOptionsMultiple 
         Caption         =   "Use &Multiple Buffers"
      End
      Begin Menu mnuOptionsSingle 
         Caption         =   "Use &Single Buffer"
      End
   End
End
Option Explicit

Const MAX_BUFFERS = 4

'pastecount is the number of local paste buffers
'It is 1-based.
Dim pastecount As Integer

'lcv (loop control variable) is used in many places
'to drive a for/next loop
Dim lcv As Integer

'dirtyflag is set to True whenever txtEditBox changes
Dim dirtyflag As Integer

'fhandle and fname are used to open (and close) the file.
Dim fhandle As Integer
Dim fname As String

Const TXT_WIDTH = .6
Const SCROLL_BAR_HEIGHT = 675

Const FormTitle = "Multiple Paste Buffer Editor v3.0"

Sub Form_Load ()
    'At load time establish sizes and positions.
    Height = screen.Height
    Width = screen.Width
    Top = 0
    Left = 0
    Caption = FormTitle + " (untitled)"
    
    'Set up the common dialog box.
    CMDialog1.Filter = "Text Files (*.txt)|*.txt|All files (*.*)|*.*"
    CMDialog1.FilterIndex = 1
    
    pastecount = 1
End Sub

Sub Form_QueryUnload (Cancel As Integer, UnloadMode As Integer)
    Dim rc As Integer
    Const YES = 6

    If dirtyflag Then
        rc = MsgBox("Save changes before terminating?", 4, "File has changed!")
        If rc = YES Then
            mnuFileSave_Click
        End If
    End If
End Sub

Sub Form_Resize ()
    txtEditBox.Width = frmMPBE.Width * TXT_WIDTH
    
    If frmMPBE.Height - SCROLL_BAR_HEIGHT > 0 Then
        txtEditBox.Height = frmMPBE.Height - SCROLL_BAR_HEIGHT
    End If
    
    label1(1).Left = frmMPBE.Width * TXT_WIDTH + 150
    
    text1(1).Left = frmMPBE.Width * TXT_WIDTH + 150
    text1(1).Width = frmMPBE.Width * .35
    text1(1).Height = txtEditBox.Height * .15
End Sub

Sub mnuBuffer_Click ()
    If pastecount >= MAX_BUFFERS Then
        mnuBufferAdd.Enabled = False
    Else
        mnuBufferAdd.Enabled = True
    End If
    
    If pastecount = 1 Then
        mnuBufferRemove.Enabled = False
    Else
        mnuBufferRemove.Enabled = True
    End If
End Sub

Sub mnuBufferAdd_Click ()
    Const delta = 1700

    pastecount = pastecount + 1
    
    Load label1(pastecount)
    label1(pastecount).Top = label1(pastecount - 1).Top + delta
    label1(pastecount).Caption = "Paste Buffer #" + LTrim$(Str$(pastecount))
    label1(pastecount).Visible = True

    Load text1(pastecount)
    text1(pastecount).Top = text1(pastecount - 1).Top + delta
    text1(pastecount).Visible = True
    text1(pastecount).Text = ""
    
    '*****FIX
    
    Load mnueditcopy(pastecount)
    mnueditcopy(pastecount).Caption = "Copy to Buffer #" + LTrim$(Str$(pastecount))
    mnueditcopy(pastecount).Enabled = True
    
    Load mnueditpaste(pastecount)
    mnueditpaste(pastecount).Caption = "Paste from Buffer #" + LTrim$(Str$(pastecount))
    mnueditpaste(pastecount).Enabled = True
End Sub

Sub mnuBufferRemove_Click ()
    'Unload the label and the text control
    
    Unload label1(pastecount)
    Unload text1(pastecount)
    
    'Unload the menu items
    '*****FIX
    
    pastecount = pastecount - 1
End Sub

Sub mnuEdit_Click ()
    Dim selectionmade As Integer

    'Don't enable paste options unless something's
    'actually in the paste buffer.
    For lcv = 1 To pastecount
        '*****FIX
    Next lcv

    'Determine if something is highlighted in the edit box.
    If txtEditBox.SelLength = 0 Then
        selectionmade = False
    Else
        selectionmade = True
    End If

    'Set enabled property for cut/copy to reflect
    'highlighting status.
    For lcv = 1 To pastecount
        '*****FIX
    Next lcv
End Sub

Sub mnuEditCopy_Click (Index As Integer)
     text1(Index).Text = txtEditBox.SelText
End Sub

Sub mnuEditCut_Click (Index As Integer)
     '*****FIX
     txtEditBox.SelText = ""
End Sub

Sub mnuEditPaste_Click (Index As Integer)
    txtEditBox.SelText = text1(Index).Text
End Sub

Sub mnuFileExit_Click ()
    Dim rc As Integer
    Const YES = 6

    If dirtyflag Then
        rc = MsgBox("Save changes before terminating?", 4, "File has changed!")
        If rc = YES Then
            mnuFileSave_Click
        End If
    End If
    
    'Terminate
    End
End Sub

Sub mnuFileNew_Click ()
    Const YES = 6
    Dim rc As Integer

    If dirtyflag = True Then
        rc = MsgBox("Save changes before a fresh start?", 4, "Text has changed!")
        If rc = YES Then
            mnuFileSave_Click
        End If
    End If
    fname = ""
    txtEditBox.Text = ""
    dirtyflag = False
    frmMPBE.Caption = FormTitle + " (untitled)"
End Sub

Sub mnuFileOpen_Click ()
    Dim rc As Integer
    Const YES = 6

    'First determine if the text box is dirty.
    If dirtyflag Then
        rc = MsgBox("Save changes before opening a new file?", 4, "File has changed!")
        If rc = YES Then
            mnuFileSave_Click
        End If
    End If

    'Invoke the Dialog Box
    CMDialog1.Action = 1

    'if fname is empty, then exit
    fname = CMDialog1.Filename
    If fname = "" Then
        Beep
        Exit Sub
    End If

    'Build the title without a path.
    frmMPBE.Caption = FormTitle + " (" + CMDialog1.Filetitle + ")"
    
    'Get a fresh handle and read the file in.
    fhandle = FreeFile
    Open fname For Input As fhandle
    txtEditBox.Text = Input$(LOF(fhandle), fhandle)
    dirtyflag = False
    Close fhandle
End Sub

Sub mnuFileSave_Click ()
    If dirtyflag = False Then
        Exit Sub
    End If
    
    'Get a fresh handle and write the file to it.
    If fname = "" Then
        fname = InputBox$("Enter a file name. File will be saved in " + CurDir$, "No file name available!")
        frmMPBE.Caption = FormTitle + " (" + fname + ")"
    End If
    
    'Now if fname is empty end this subroutine.
    If fname = "" Then
        Exit Sub
    End If

    fhandle = FreeFile
    Open fname For Output As fhandle
    Print #fhandle, txtEditBox.Text
    Close fhandle
    dirtyflag = False

End Sub

Sub mnuFileSaveExit_Click ()
    mnuFileSave_Click
    End
End Sub

Sub mnuOptionsMultiple_Click ()
    'Exit if already checked
    '*****fix #1

    'Toggle the check marks.
    '*****fix #2
    '*****fix #3
    
    'Restore the height of buffer 1.
    text1(1).Height = txtEditBox.Height * .15
    
    'Make the buffers menu visible.
    '*****fix #4
End Sub

Sub mnuOptionsSingle_Click ()
    If mnuOptionsSingle.Checked = True Then
        Exit Sub
    End If
    
    'Toggle the check marks.
    mnuOptionsSingle.Checked = True
    mnuOptionsMultiple.Checked = False

    'Hide the top level menu.
    '*****FIX

    'Unload any added paste buffers and their menus.
    For lcv = 2 To pastecount
        '*****FIX
    Next lcv

    'Set the count to 1.
    pastecount = 1
    
    'Make the remaining buffer full height.
    text1(1).Height = txtEditBox.Height - 3 * text1(1).Top
End Sub

Sub txtEditBox_Change ()
    dirtyflag = True
End Sub

